<template>
    <div class="c_box">
        <!-- <div class="mask"></div> -->
        <div v-if="!checkJson">暂未设置题目</div>
        <div v-else class="choice_box">
            <div class="c_title">
                <div class="title" style="display: flex;">
                    <!-- + `（${option[checkJson.type].name}）` -->
                    <span style="min-width: fit-content;">{{ tindex + 1 + "、" }}</span>
                    <span>{{ checkJson.title }}</span>
                    <!-- {{ tindex + 1 + "、" + `（${option[checkJson.type].name}）` + checkJson.title }} -->
                    <span style="min-width: fit-content;" v-if="checkJson.type == 2">{{
            `（${option[checkJson.type].name}）` }}</span>
                    <span style="color: #efa030;min-width: fit-content;" v-if="checkJson.score">（{{ '分值：' +
            checkJson.score + '分' }}）</span>
                </div>
                <div class="p_box" v-if="isTeacher == 1 && checkJson.score">
                    <el-input v-model="score2" class="c_input" disabled></el-input><span
                        style="margin: 0 10px;">/</span><span>{{ checkJson.score }}分</span>
                </div>
                <div class="p_box" v-if="isTeacher == 2 && checkJson.score2">
                    <span>{{ checkJson.score2 }}分</span><span style="margin: 0 10px;">/</span><span>{{ checkJson.score
                        }}分</span>
                </div>
            </div>
            <div class="choices">
                <div class="choice" v-for="(item, index) in checkJson.array" :key="index">
                    <div class="choice_c" v-if="checkJson.type == 2"><el-checkbox v-model="checkJson.answer2"
                            :label="index" :disabled="checktype == 2" @change="changeJson"></el-checkbox><span
                            :class="{ right: see && cJson.answer.indexOf(index) != -1 }"
                            @click="check(checkJson.type, index)">{{ item.option }}</span></div>
                    <div class="choice_c" v-if="checkJson.type == 1"><el-radio v-model="checkJson.answer2[0]"
                            :label="index" :disabled="checktype == 2" @change="changeJson"></el-radio><span
                            :class="{ right: see && cJson.answer.indexOf(index) != -1 }"
                            @click="check(checkJson.type, index)">{{ item.option }}</span></div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
export default {
    props: {
        tindex: {
            type: Number
        },
        cJson: {
            type: Object,
        },
        checktype: {
            type: Number,
            default: 1
        },
        see: {
            type: Boolean,
            default: false
        },
        isTeacher: {
            type: Number,
            default: 2
        }
    },
    data() {
        return {
            option: {
                1: { name: '单选题' },
                2: { name: '多选题' }
            },
            checkJson: undefined
        }
    },
    computed: {
        score2() {
            let answer2 = this.checkJson.answer2 ? this.checkJson.answer2.sort().join(',') : ''
            let answer = this.checkJson.answer ? this.checkJson.answer.sort().join(',') : ''
            this.checkJson.score2 = (answer2 == answer ? this.checkJson.score : 0)
            this.$forceUpdate();
            return answer2 == answer ? this.checkJson.score : 0
        }
    },
    watch: {
        checkJson: {
            handler(newValue) {
                console.log(1);
                this.$emit('update:cJson', newValue)
                this.$forceUpdate()
            },
            deep: true
        },
        cJson: {
            handler(newValue) {
                if (JSON.stringify(newValue.answer2) !== JSON.stringify(this.checkJson.answer2)) {
                    this.checkJson = this.depthCopy(newValue)
                    this.$forceUpdate()
                }
            },
            deep: true
        },
    },
    methods: {
        changeJson() {
            console.log(1);
            this.$forceUpdate()
            this.$emit('update:cJson', this.checkJson)
            this.$forceUpdate()
        },
        depthCopy(s) {
            return JSON.parse(JSON.stringify(s));
        },
        check(type, index) {
            if (this.checktype == 2) {
                return;
            }
            if (type == 2) {
                if (this.checkJson.answer2.indexOf(index) == -1) {
                    this.checkJson.answer2.push(index)
                } else {
                    this.checkJson.answer2.splice(this.checkJson.answer2.indexOf(index), 1)
                }
            } else if (type == 1) {
                this.checkJson.answer2[0] = index
            }
            console.log(1);
            this.$emit('update:cJson', this.checkJson)
            this.$forceUpdate()
        }
    },
    mounted() {
        this.checkJson = this.cJson ? this.depthCopy(this.cJson) : undefined
    }
}
</script>

<style scoped>
.c_box {
    width: 100%;
    position: relative;
}

.mask {
    position: absolute;
    height: 100%;
    width: 100%;
    z-index: 2;
}

.choice_box {
    white-space: pre-line;
}

.choice_box>.c_title .title {
    font-weight: bold;
    width: 100%;
    word-break: break-all;
}

.choice_box>.c_title {
    display: flex;
    justify-content: space-between;
}

.choice_box>.c_title .p_box {
    margin-left: 5px;
    min-width: fit-content;
    display: flex;
    align-items: center;
}

.choice_box>.choices {
    margin-top: 10px;
    padding: 0 10px;
}

.choice_box>.choices>.choice {
    word-break: break-all;
}

.choice_box>.choices>.choice+.choice {
    margin-top: 5px;
}

.choice_box>.choices>.choice>.choice_c {
    display: flex;
}

.choice_box>.choices>.choice>.choice_c>span {
    /* margin-left: 10px; */
    cursor: pointer;
}

.choice_box>.choices>.choice>.choice_c>.el-checkbox {
    margin-top: 4px;
    margin-right: 10px;
}

.choice_box>.choices>.choice>.choice_c>.el-radio {
    margin-top: 4px;
    margin-right: 10px;
}

.choice_c>>>.el-checkbox__label {
    display: none;
}

.choice_c>>>.el-radio__label {
    display: none;
}

.choice_c .right {
    color: #efa030;
}

.choice_c .right::after {
    content: '（正确答案）';
}

.choice_box>.choices>.choice>>>.el-checkbox__input.is-disabled.is-checked .el-checkbox__inner::after {
    border-color: #fff !important;
}

.choice_box>.choices>.choice>>>.el-checkbox__input.is-disabled.is-checked .el-checkbox__inner {
    background-color: #409EFF !important;
    border-color: #409EFF !important;
}

.choice_box>.choices>.choice>>>.el-radio__input.is-disabled.is-checked .el-radio__inner {
    background-color: #409EFF !important;
    border-color: #409EFF !important;
}

.choice_box>.choices>.choice>>>.el-radio__input.is-disabled.is-checked .el-radio__inner::after {
    background-color: #fff !important;
}

.c_input {
    width: 90px;
}

.c_input>>>.el-input__inner {
    padding: 0 5px;
    text-align: right;
}
</style>